-- Ci-dessous les requtes "select de base", les plus importantes
-- 2 requtes vitales

-- il dit sur quelle base de donnes on travaille. Il change la base par dfaut.
use ContosoRetailDW

-- 1 re : compter le nombre de lignes d'une table

select count(*)
from DimCustomer

set statistics time on
select count(*)
from FactOnlineSales

-- 2me : afficher les n premire lignes d'une table. 
select TOP 15 *
from DimCustomer

-- il permet de vider le cache (lieu de stockage des donnes)
DBCC FREEPROCCACHE
-- dbcc dropcleanbuffers

set statistics time on
select TOP 1000 *
from DimCustomer

-- 3 - test dangereux, selectionner toutes les lignes et colonnes d'une table 
-- from FactOnlineSales

select TOP 1000000 *
from FactOnlineSales
use comptoir

-- 5 . Penser au top au dpart / Aprs avoir mis les conditions, l'enlever
-- Je souhaite les hommes clibataires et ns avant 1970
-- Rsultat : 2617
select *
from DimCustomer
where gender='M' and maritalstatus ='S' 
	and year(birthdate) < 1970
-- and BirthDate <'1970-01-01'

-- 6. Pratiquement pareil, sauf qu'au lieu de vouloir ceux ns avant 1970
-- Je souhaite rcuprer toutes les annes sauf l'anne 1966
-- Rsultat: 3932
select *
from DimCustomer
where gender='M' and maritalstatus ='S' 
	and year (BirthDate) <>'1966'

-- 7. Tous ceux qui sont ns en 1975 et en 1977 (utilisation du in)
-- Dans ContosoRetailDW
-- Rsultat : 864

select *
from DimCustomer
where year (BirthDate) ='1975' or year (BirthDate) ='1977'

-- mais vaut mieux a : (utilisation du in)
select *
from DimCustomer
where year (BirthDate) in(1975,1977)

-- 8. Je souhaite les personnes quand l'education (sur dimcustomer) est = les bachelors et high school
-- Dans ContosoRetailDW

select TOP 100 *
-- count(*)
from DimCustomer
where Education in('Bachelors', 'High School')

-- 9. je veux compter le nombre de rsultat du l'xo 8
-- Dans ContosoRetailDW
-- Rsultats : 8650 

select count(*)
from DimCustomer
where Education in('Bachelors', 'High School')


-- 10. Je veux afficher les bachelors et high school mais ceux qui ne sont pas ns en 75 et 77
-- Dans ContosoRetailDW
-- Rsultat : 8249

select customerkey, firstname, lastname
from DimCustomer
where year (BirthDate) not in(1975,1977) and Education in('Bachelors', 'High School')


-- 11 dans la table DimCustomer, je veux le champ last name, lanne de naissance, le sexe 
--pour tous ceux qui ont plus de 2 enfants et qui gagnent entre 10000 et 30000 dollars par an. 
-- Dans ContosoRetailDW
-- Rsultats : 1078 lignes

select 
LastName, BirthDate, Gender, YearlyIncome, TotalChildren
from DimCustomer
where TotalChildren >'2' and YearlyIncome between'10000' and'30000'

-- 12 Idem mais tous ceux qui sont ns entre 1960 et 1970
-- Dans ContosoRetailDW
-- Rsultats : 416 lignes

select 
LastName, BirthDate, Gender, YearlyIncome, TotalChildren
from DimCustomer
where TotalChildren >'2' and YearlyIncome between'10000' and'30000'
and year (BirthDate) between '1960' and '1970'


-- 13. Tous les champs pour lanne 2007 dont le discountamount (remise de la vente) est compris entre 15 et 20.
-- Dans ContosoRetailDW et table FactOnlineSales
-- Rsultats : 155920

select  top 100 * 
-- select count(*) 
from FactOnlineSales
where DiscountAmount between '15' and '20' and year (DateKey)='2007'

-- 14 : Je veux la liste de chaque type dducation pour connatre les critres existants dans la table. 
-- exclure null
-- Dans ContosoRetailDW  et Table dimcumstomer
-- Rsultats : 5 lignes

select distinct Education 
--select count (*) 
from DimCustomer
where education is not null

-- 15 : Je veux compter le nombre de clients pour lesquels Education est NULL
-- Dans ContosoRetailDW et Table dimcumstomer
-- Rsultats : 385

-- select distinct Education 

select count(*) 
from DimCustomer
where education is null

select * from DimCustomer

-- 16 : Je veux compter le nombre de clients par genre et par ducation
-- Je ne veux pas les NULL
-- Dans ContosoRetailDW et Table dimcumstomer
-- Rsultats : 10 lignes (ou 11 si NULL pas exclus)

select gender, education, count(CustomerKey)
 from DimCustomer 
 where Gender is not null
group by Gender, Education 


-- si on souhaite trier order by 'education'
--  order by 'education'

-- 17. Je veux compter le nombre de clients par anne de naissance et par sexe
-- Dans ContosoRetailDW et sur la table dimcustomer
-- Rsultats : 135

select  year(birthdate), gender, 
 count(CustomerKey) as 'nombre clt'
 from DimCustomer
 group by year(birthdate), gender


-- 18 sur FactOnlineSalesSales
-- Je veux par anne, le total des montants des ventes (salesamount) 
-- et le nombre total de ventes
-- Dans ContosoRetailDW et Table factonlinesales
-- Rsultats : 3 lignes
use ContosoRetailDW
select top 100 * from FactOnlineSales

select year(datekey) as 'anne',
       sum(salesamount) as ' somme des ventes',
	   count(onlinesaleskey) as 'nombre de ventes'
from FactOnlineSales
group by year(datekey)


-- 19 sur FactOnlineSales : pareil que pour l'exo 18 mais 
-- je veux seulement quand le nombre de ventes est superieur  5 000 000
-- Dans ContosoRetailDW et Table factonlinesales
-- Rsultat : 1 lignes de rsultats

select year(datekey) as 'anne',
       sum(salesamount) as ' total des ventes',
       count(onlinesaleskey) as 'nombre de ventes'
from FactOnlineSales
group by year(datekey)
having count(onlinesaleskey) > '5000000'


-- 20 Je veux afficher tous les produits (productname) qui contiennent le mot mp3 (et uniquement ceux-l)
-- Dans ContosoRetailDW et sur la table DimProduct
-- Rsultats : 35 lignes

select * 
from DimProduct
where ProductName like '%mp3%'

-- 20.1 Suite du 20
-- Je veux compter ces produits par couleur et n'afficher que les couleurs qui ont plus de 5 produits mp3
-- Dans ContosoRetailDW et sur la table DimProduct
-- Rsultats : 2 lignes (noir et blanc)

select count(productname), ColorName
from DimProduct
where ProductName like '%mp3%' 
group by ColorName
having count(productname) >5

-- 20.2 Comme 20.1 mais je renomme les couleurs du resulat en francais dans une nouvelle colonne
-- Dans ContosoRetailDW et sur la table DimProduct

select 	
	case 
		when ColorName='Black' then 'noir'
		when ColorName='white' then 'blanc'
	end as 'nomfr'
	, count(productname) as 'nombre de produits'
from DimProduct
where ProductName like '%mp3%' 
group by ColorName
having count(productname) >5

-- 21. Je veux le nom, prnom et date de naissance ainsi que l'ge des employs 
-- quand la date de naissance est connue
-- je veux afficher la date de naissance en date simple (Anne, mois, jour)
-- Dans Comptoir
-- Rsultats : 8 lignes

select EmployeNom, EmployePrenom, 
		cast(EmployeDteNaiss as date) as 'date de naissance', 
		DATEDIFF(year,EmployeDteNaiss,getdate()) as 'Age'
		-- ,cast ( DATEDIFF (dd, EmployeDteNaiss, Getdate()) / 365.25 as int)  as 'age'
from T_Employe
where EmployeDteNaiss is not null