---------------------------------MONO TABLES --------------------------------------------------------------


/************************** COMMANDES DE BASES EXERCICES - 2eme DOCUMENT *********************************/

-- 1 Je veux la liste des produits qui sont de classe Economy et de type de stock Mid,  
-- par ordre alphabtique
-- Rsultat : 300 lignes

use ContosoRetailDW
select distinct
	productname
from DimProduct
where
	ClassName ='economy' and 
	StockTypeName = 'Mid' 
	
order by
	ProductName desc

-- 2 Je veux la liste des prnoms des clients pour les hommes qui ont un firstname qui commence par j ou par l 
-- Rsultat : 58 lignes

use ContosoRetailDW
select distinct
	-- gender, permet de savoir si on a bien que des hommes qui sortent dans la requte - toujours vrifier les rsultats
	FirstName
From DimCustomer

where 
	gender = 'M'
and 
-- left(firstname,1) in ('j','l')
(FirstName like 'j%' or firstname like 'l%')


-- 3 Je veux le nombre de personnes (dans la table DimCustomer) 
-- Qui ont un firstname qui commence par j ou l par genre.
-- J'exclu les null du champ gender
-- Rsultat : 2 lignes (femmes : 1263 et hommes 1784)

use ContosoRetailDW

select distinct
	Gender as 'genre',
	COUNT(customerkey) as 'Nombre de personnes'
From DimCustomer
where  
(FirstName like 'j%' or firstname like 'l%')
and gender IS NOT NULL 
group by
gender

-- 4 Je veux les noms, le contact, et l'adresse complte des clients qui ont pour fonction "marketing assistant"
-- et qui sont aux USA ou au CANADA
-- Rsultat : 3 lignes 

use comptoir

select 
	clientnom,
	clientcontact,
	ClientAddress,
	ClientVille,
	ClientCP
	-- ClientContactFonction, permet de vrifier que le or fonctionne
	-- ClientPays, permet de vrifier que le or fonctionne
from T_Client
where
	(ClientPays='USA' or ClientPays='Canada')
	and upper(ClientContactFonction)='Marketing Assistant'

-- 5 je souhaite toutes les colonnes pour les 2 types de clients 
-- 1re typologie : qui vivent  strasbourg et qui ont un contact ayant la fonction de Marketing Manager
-- et ceux de la 
-- 2me typologie : qui vivent  Madrid et qui ont ont un contact ayant la fonction d'OWNER
-- rsultat : 2
-- modifier BDD= un client  madrid + marketing manager
use comptoir
SELECT *
  FROM T_Client
  where clientville IN ('Strasbourg','Madrid') 
  and ClientContactFonction IN ('Marketing Manager','Owner')

SELECT *
  FROM T_Client
  where (clientville = 'Strasbourg' and ClientContactFonction = 'Marketing Manager')
  or (ClientVille = 'Madrid' and ClientContactFonction = 'Owner')

-- 6 je veux compter le nombre de produits qui sont de classe Economy et qui contiennent le mot 'games' dans leur nom
-- Rsultat : 26

use ContosoRetailDW

select
	count(ProductKey)
from DimProduct
where
	ClassName ='economy'
and ProductName like '%games%'
 
-- 7 Compter le nombres de femmes qui ont un firstname qui finit par l mais qui ne commence pas par a
-- Rsultat : 254

use ContosoRetailDW
select
	count(customerkey) as 'nombre de femmes'
From DimCustomer
where 
	gender = 'F'
and FirstName like '%l' 

and FirstName not like 'a%'

-- 8 Compter le nombres d'hommes qui avaient entre 20 et 40 ans au moment du chargement des donnes (loadate)
-- et qui ont un firstname qui contient la lettre y
-- Rsultat : 433

SELECT top 100 *
FROM DimCustomer

use ContosoRetailDW
select
	-- datediff(year, BirthDate, LoadDate) as 'age', -- afin de voir si l'age est bon
	count(customerkey) as 'nombre d"hommes'
From DimCustomer
where 
	gender = 'M'
and datediff(year, BirthDate, LoadDate) between '20' and '40' 
and FirstName like '%y%' 
-- group by
	-- datediff(year, BirthDate, getdate())  -- si on vrifie l'ge, oblig de le remettre l  cause du count

-- 9 Je veux le total des quantits des ventes (salesquantity) pour lesquels le prix  l'unit (unitprice) est gal  31,39 euros
-- Sur table FactOnlineSales
-- Rsultat : 4628

use ContosoRetailDW
select
	sum(salesquantity) as 'somme des ventes'
from FactOnlineSales
where UnitPrice='31.39'

--  10 Pareil mais aussi lorsque le discountAmount est gal  6 
-- Rsultat : NULL

use ContosoRetailDW
select
	sum(salesquantity) as 'somme des ventes'
from FactOnlineSales
where UnitPrice='31.39'
and DiscountAmount='6'

-- 11 Je veux compter le nombre de produits qui ont un prix unitaire (ProduitPU) entre 15 et 28 et qui font partie de la catgorie 2
-- et dont le nom du produit contient la lettre e
-- Rsultat : 6

use comptoir
select
	count(produitID)
from T_Produit
where
	ProduitPU between '15' and '28'
and CategorieID = '2'
and produit like '%e%'

-- 12 Idem que pour lexercice 3 sauf que je veux renommer mes lignes de rsultats :
-- F : devient Femme et H devient Homme (modifications des valeurs du champ GENDER)

use ContosoRetailDW
 
select distinct
	-- Gender as 'genre', -- a la place mettre le recodage CASE WHEN
Case
    When Gender = 'M' Then 'Hommes'
    When Gender = 'F' Then 'Femmes'
 Else 'Inconnu' End 'Genre',
	COUNT(customerkey) as 'Nombre de personnes'

From DimCustomer
where  
FirstName like 'j%' or firstname like 'l%'
group by
Gender

-- 13 Dans DimProduct, compter les produits par ColorName
-- Rsultat : 16 lignes

use ContosoRetailDW
 
select 
	colorname,
	count(productkey) as 'nombre de produits'
from 
DimProduct
group by colorname

 --14  Dans FactSales, nombre de ventes (saleskey), 
-- Somme et moyenne des ventes (salesamount) par anne et par mois
-- Je veux les ordonner par anne et par mois
-- Quand la somme des ventes est suprieur  300000000
-- Rsultat : 28 lignes

select top 100 * from FactOnlineSales

select 
year(datekey) anne,
	month(datekey)'mois',
	count(SalesKey) 'nombre',
	sum(SalesAmount) as'cumul des ventes',
	avg(salesamount) as 'moyenne des ventes'
from 
FactSales
group by 
	year(datekey),
	month(datekey)
having sum(SalesAmount) > 300000000
order by
	year(datekey),
	month(datekey)


--15 Dans dimcustomer , afficher le maritalstatus, gender, birthday, yearlyincome
-- Pour les femmes clibataires nes entre 1950 et 1970 et qui gagnent plus de 5000 par an
-- Utilisation de la fonction UPPER (dans les conditions where)
-- Rsultat : 2497 lignes

use ContosoRetailDW

select -- distinct
	Maritalstatus,
	gender,
	BirthDate,
	yearlyincome

from DimCustomer

where
	upper(MaritalStatus) = 'S' -- que fait ce critre : il met en majuscule. 
	-- SI on ne sait pas si serveur est sensible  la casse, il vaut mieux du upper afin qu'il comprenne mme si accents ou autre

and
	upper(gender) = 'F'
	and
	year(BirthDate) between '1950' and '1970'
	and
	YearlyIncome > '5000'

-- 16 Je souhaite concatner plusieurs champs
-- Afficher l'adresse (nom, adresse, cp, ville, pays) spar de virgule dans un mme champ
use comptoir
Select trim(clientnom) +', '+ trim(clientaddress) + ','+trim(clientcp)+','+trim(clientville)+','+trim(ClientPays)
From t_client 

-- correction pour SQL antrieur  2017
Select ltrim(rtrim(clientnom)) +', '+ ltrim(rtrim(clientaddress)) + ','+ltrim(rtrim(clientcp))+','+ltrim(rtrim(clientville))+','+ltrim(rtrim(ClientPays)) as 'adresse entire'
From t_client

-- orsys problme avec le trim, impossible de le faire
use comptoir
Select clientnom +','+ clientaddress + ','+ clientcp +','+ clientville +','+ ClientPays
From t_client 

/* 17. Je souhaite afficher le Nom de famille (LastName) suivi de la premire lettre du prnom suivie d'un point
ensuite "est un(e)" suivi du genre et de la situation familiale crit en entier (case)
suivi de " et mail : " et l'adresse 
Colonne que je renomme Informations clients.

Seulement pour les clients pour lesquels nous avons une information sur le genre et la situation familiale
Rsultat premire ligne : Yang J. est un(e) Homme Mari et mail : jon24@adventure-works.com
Nombre de lignes de rsultats : 18484
*/
Use ContosoRetailDW
SELECT top 100 * from DimCustomer

select LastName + Space(1) + SUBSTRING(FirstName, 1, 1) + '. '   + 'est un(e) ' +
	(case
		when Gender = 'M' and MaritalStatus = 'S'  then 'Homme Clibataire'
		when Gender = 'M' and MaritalStatus = 'M'  then 'Homme Mari'
		when Gender = 'F' and MaritalStatus = 'S' then 'Femme Clibataire'
		when Gender = 'F' and MaritalStatus = 'M' then 'Femme Marie'
		else 'pas d''infos'
	end) 
	+ ' et mail : ' + EmailAddress  as 'informations clients'
	
from DimCustomer
where gender is not null and MaritalStatus is not null

-- 18. Je souhaite afficher le nom, prnom, date d'embauche des employees (table employees) ainsi que le nom du dpartement et le titre du job (tables departements et jobs)
-- Je souhaite crer des tranches d'anciennet : Moins de 25 ans d'anciennet, 30, 35, 40, 40 ans et plus
-- 40 lignes
Use Sample_database

SELECT 
    first_name,
    last_name,
    hire_date,
	department_name,
	job_title,
    CASE 
		WHEN hire_date IS NULL THEN 'Date d''embauche inconnue'
        WHEN DATEDIFF(year,hire_date,getdate()) < 25 THEN 'Moins de 25 ans d''anciennet'
        WHEN DATEDIFF(year,hire_date,getdate()) < 30 THEN 'Moins de 30 ans d''anciennet'
        WHEN DATEDIFF(year,hire_date,getdate()) < 35 THEN 'Moins de 35 ans d''anciennet'
        WHEN DATEDIFF(year,hire_date,getdate()) < 40 THEN 'Moins de 40 ans d''anciennet'
        Else '40 ans d''anciennet et plus'
    END Anniversaire
FROM
    employees e join jobs j on e.job_id=j.job_id 
				join departments d on E.department_id=d.department_id
ORDER BY department_name, job_title, hire_date
