use AdventureWorks2012

-- 13. Tous les champs pour lanne 2006 dont le prix  l'unit est compris entre 50 et 100.
-- table Sales.SalesOrderDetail
-- Rsultats : 1060

select   * 
-- select count(*) 
from Sales.SalesOrderDetail
where UnitPrice between '50' and '100' and year (Modifieddate)='2006'

-- 14 : Je veux la liste de tous les jobtitle
-- exclure null : IS NOT NULL
-- Dans HumanResources.Employee
-- Rsultats : 67 lignes

select distinct jobtitle
from HumanResources.Employee
where jobtitle is not null

-- 15 : Je veux compter le nombre de clients par type de Jobtitle
-- Trier par nombre d'employs : les jobs pour lesquel il y a le plus d'employs doivent apparatre en premier
-- Dans HumanResources.Employee
-- Rsultats : 67

-- select distinct Education 
select count(BusinessEntityID) 'nombre d''employs', jobtitle
from HumanResources.Employee
Group by Jobtitle
Order by count(businessEntityID) desc


-- 16 : Je veux compter le nombre de clients par genre et situation familiale
-- Quand le salariFlag est gal  1
-- et quand le titlejob est soit Chief Executive Officer soit Vice President of Engineering
-- Dans HumanResources.Employee
-- Rsultats : 3 lignes (2 pour hommes maris, 1 femme clibataire et un homme clibataire)

select count(businessEntityId) as 'Nombre d''employs',
Gender, MaritalStatus
from HumanResources.Employee
Where SalariedFlag = 1 and JobTitle in ('Chief Executive Officer','Vice President of Engineering', 'Research and Development Manager')
group by Gender, MaritalStatus

-- 17. Je veux compter le nombre d'employs par anne de naissance et par sexe
-- Dans HumanResources.Employee
-- Rsultats : 63
Select count(businessentityid) as 'Nombre d''employes' , year(birthdate) as 'Anne', Gender
from HumanResources.Employee
Group by year(birthdate), Gender

-- 18. La suite du 17 mais avec nouvelle condition : 
-- Et n'afficher le rsultat que pour les annes et le genre qui ont minimum 5 employs
-- Dans HumanResources.Employee
-- Rsultats : 26
Select count(businessentityid) as 'Nombre d''employes' , year(birthdate) as 'Anne', Gender
from HumanResources.Employee
Group by year(birthdate), Gender
Having count(businessentityid) >= 5


-- 19 Je veux afficher tous les produits (productid et name) 
-- qui contiennent le mot crown ainsi que ceux qui ont leur nom qui commence par Flat
-- et pour lesquels le stock est de 1000 produits minimum
-- Table Production.Product
-- Rsultats : 35 lignes

select Productid, name
from Production.Product
where (name like '%crown%' or name like 'Flat%')
		and SafetyStockLevel>= 1000


-- 20 Suite du 16, mais ii je souhaite avoir une colonne qui regroupe le genre et la situation familiale
-- de l'employ crit correctement (Homme mari par exemple).
-- Dans HumanResources.Employee

select count(businessEntityId) as 'Nombre d''employs',
	CASE
		When gender = 'M' and maritalstatus = 'M' THen 'Homme mari'
		When gender = 'M' and maritalstatus = 'S' THen 'Homme clibataire'
		When gender = 'F' and maritalstatus = 'M' THen 'Femme marie'
		When gender = 'F' and maritalstatus = 'S' THen 'Femme clibataire'
	END as 'Genre et sit familiale'
from HumanResources.Employee
Where SalariedFlag = 1 and JobTitle in ('Chief Executive Officer','Vice President of Engineering', 'Research and Development Manager')
group by Gender, MaritalStatus